// Ecole Thématique 2014 -- Conception de simulateurs médico-chirurgicaux

// Résolution numérique d'EDP --- Exercices simples sur les différences finies

clear; clc; clf 

//////////////////////////////////////////////////
//// Exercice 1: Schéma de type Euler explicite
//////////////////////////////////////////////////

// Défintion d'une fonction...
function y = myfunction (x) 
    y = x*x;
endfunction

// ... et de sa dérivée numérique
function fp = myfprime(f,x,h) 
    fp = (f(x+h) - f(x))/h;
endfunction

disp('Exercice 1')

// Choix de x et valeur exacte de f'(a)
a = 1.0;
fpexact = 2.;

// Calcul de f'(a) avec DF
h = 1.e-1;
fp = myfprime(myfunction ,a,h);
e = abs(fp-fpexact)/fpexact;
mprintf("Naive f’’=%e, error=%e\n", fp,e);

// Utilisation de la fonction native de scilab pour le calcul numérique 
// de dérivées
fpref = derivative(myfunction ,a);
e = abs(fpref-fpexact)/fpexact; 
mprintf("Scilab f’’=%e, error=%e\n", fpref,e); 

// Correction !!
for i=1:20
h=h/10.0;
fp = myfprime(myfunction ,a,h);
e = abs(fp-fpexact)/fpexact;
mprintf("Naive f’’=%e, h=%e, error=%e\n", fp,h,e); end


disp('Fin Exercice 1')
